//
// SSText.java: Class file for WO Component 'SSText'
// Project SwitchableString52
//
// Created by psuh on Wed Aug 06 2003
//
/*
 
 Copyright (c) 2003 Paul Suh. All rights reserved.
 
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 
 * Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.
 
 * Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in the
 documentation and/or other materials provided with the distribution.
 
 * Neither the name of the site goodeast.com nor the names of its
 contributors may be used to endorse or promote products derived from
 this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 */
package com.goodeast.webobjects.switchablestring;


import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.appserver._private.*;


/**
    SwitchableString replacement for WOText. Most of the work is done by the code
    in the SSHelper class. 
*/
public class SSText extends WOText implements SSHelper.Callbacks {

    /**
        The bindings that are used only by this class -- to be 
        striped out of the associations dictionary before it is passed up the line
        to the super-class constructor. 
    */
    protected static NSArray _myAssociations = new NSArray( new String[] { "editable", "allowedTags", "disallowedTags", "truncateLength" } );

    protected NSDictionary _associationsDict;

    public SSText( String aName, NSDictionary associations, WOElement template) {
        super( aName, SSHelper.cleanUpAssociations( associations, _myAssociations ), template );

        _associationsDict = associations;
    }


    public void appendToResponse( WOResponse r, WOContext c ) {

        SSHelper.performAppendToResponse( r, c, _associationsDict, this );
    }

    public void takeValuesFromRequest( WORequest r, WOContext c ) {

        SSHelper.performTakeValuesFromRequest( r, c, _associationsDict, this );

    }

    public void callSuperAppendToResponse( WOResponse r, WOContext c ) {
        super.appendToResponse( r, c );
    }

    public void callSuperTakeValuesFromRequest( WORequest r, WOContext c ) {
        super.takeValuesFromRequest( r, c );
    }

}
